您的位置:首页 > 其它

Leetcode 292[easy]---Nim Game

2017-12-06 21:32 323 查看
难度:easy

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first
turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.
思路:题意简单不解释了。分析可以发现,当石头数为1,2或3时,我方赢。石头数为4时,对方赢。石头数为5,6,7时,我方拿走1个,2个或者3个,留下4个石头给对方的时候,我方赢.....可以发现,只要石头的数量不是4的倍数,我方就可以赢。,

内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode 算法